#
# spec file for package uid_wrapper
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


############################# NOTE ##################################
#
# This is a special library. You are not able to link this library.
# Do NOT create library package or a devel package!
#
############################# NOTE ##################################

Name:           uid_wrapper
Version:        1.2.4
Release:        lp150.1.7

Summary:        A wrapper for privilege seperation
License:        GPL-3.0+
Group:          Development/Libraries/C and C++
Url:            http://cwrap.org/

Source0:        https://ftp.samba.org/pub/cwrap/%{name}-%{version}.tar.gz
Source1:        %{name}-rpmlintrc

BuildRequires:  cmake
BuildRequires:  libcmocka-devel
BuildRequires:  pkg-config

Requires:       cmake
Requires:       pkg-config

%description
Some projects like a file server need privilege separation to be able to switch
to the connnection user and do file operations. uid_wrapper convincingly lies
to the application, letting it believe it is operating as root and even
switching betwen UIDs and GIDs as needed.

To use it, set the following environment variables:

LD_PRELOAD=libuid_wrapper.so
UID_WRAPPER=1

This package does not have a devel package, because this project is for
development/testing.

%prep
%setup -q

%build
# CMAKE_SKIP_RPATH:BOOL=OFF is need to run the tests!
%cmake \
  -DUNIT_TESTING=ON

make %{?_smp_mflags} VERBOSE=1

%install
%cmake_install

%check
pushd build
make %{?_smp_mflags} test || cat $(find Testing -name "*.log")
popd

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc AUTHORS README ChangeLog COPYING
%{_libdir}/libuid_wrapper.so*
%dir %{_libdir}/cmake
%dir %{_libdir}/cmake/uid_wrapper
%{_libdir}/cmake/uid_wrapper/uid_wrapper-config-version.cmake
%{_libdir}/cmake/uid_wrapper/uid_wrapper-config.cmake
%dir %{_libdir}/pkgconfig
%{_libdir}/pkgconfig/uid_wrapper.pc
%{_mandir}/man1/uid_wrapper.1*

%changelog
* Tue Jul 25 2017 asn@cryptomilk.org
- Update to version 1.2.4
  * Added deadlock workaround for glibc < 2.24
  * Fixed a possible deadlock bug if uid_wrapper is turned off
* Fri Jul 14 2017 asn@cryptomilk.org
- Update to version 1.2.3
  * Logging is always turned on now
  * Fixed a memory leak
  * Limited number of groups during fork+exec
* Thu Jul 13 2017 asn@cryptomilk.org
- Update to version 1.2.2
  * Added support for fork'ed and then exec'ed processes
  * Added support for Alpha
* Mon Mar 21 2016 asn@cryptomilk.org
- Update to version 1.2.1
  * Documented missing options.
  * Fixed a comipilation issue with -O3.
* Sun Feb 14 2016 jengelh@inai.de
- Editorial fixes to the description
* Thu Oct 29 2015 asn@cryptomilk.org
- Update to version 1.2.0
  * Added privilege checks for all set*uid and set*gid functions.
  * Added a lot more and accurate tests which work as root.
  * Fixed some minor issues
* Wed Sep  2 2015 asn@cryptomilk.org
- Update to version 1.1.1
  * Fixed getres(uid|gid) detection if unsupported.
  * Fixed the configure on Solaris
  * Added a lot more tests
* Fri Jun 26 2015 mpluskal@suse.com
- Rename rpmlintrc so that it complies with packaging guidelines
- Add rpmlintrc as source
* Thu Jun 25 2015 asn@cryptomilk.org
- Fix make install
* Mon May 11 2015 asn@cryptomilk.org
- Cleanup specfile
* Wed Jan 21 2015 asn@cryptomilk.org
- Update to version 1.1.0
  * Added support for gesresuid().
  * Added support for gesresgid().
  * Added MacOSX support.
  * Added fully working thread support.
  * Added more tests.
  * Fixed issues with older gcc versions.
* Mon Oct  6 2014 asn@cryptomilk.org
- Fix test on AArch64.
* Thu Jul 31 2014 asn@cryptomilk.org
- Update to version 1.0.2.
  * Added better logging system.
  * Added a mapnpage
  * Added build and install instructions
  * Fixed threading issue in the desctructor.
* Thu Feb 13 2014 asn@cryptomilk.org
- Initial package.
